program user_port;

uses
  dos,crt;

const
  hx           : array[0..15] of char = '0123456789ABCDEF';

var
  tick         : longint;
  osvector     : integer;
  command      : string;
  dirname      : char;
  a,b,c        : byte;
  p,q,r        : integer;
  data, status : word;
  control      : word;

function hex(h: byte): string;
begin
  hex:=hx[(h shr 4)]+hx[h and $0f];
end;

function whex(h: word): string;
begin
  whex:=hex(h shr 8)+hex(h and $ff);
end;

function ready: boolean;
begin
  ready:=(port[status] and $80)>0;
end;

function send(a: byte): boolean;
begin
  port[control]:=$20;
  tick:=meml[$40:$6c];
  repeat until (ready or ((meml[$4c:$6c]-tick)>5));
  if ready then
  begin
    port[control]:=$00;
    port[data]:=a;
    port[control]:=$02;
    tick:=meml[$40:$006c];
    repeat until (not ready or ((meml[$40:$6c]-tick)>5));
    send:=not ready;
  end else
  begin
    send:=false;
    writeln('send false');
  end;
  port[control]:=$20;
end;

function recv(var a: byte): boolean;
begin
  port[control]:=$20;
  tick:=meml[$40:$6c];
  repeat until (ready or ((meml[$40:$6c]-tick)>2));
  if ready then
  begin
    a:=port[data];
    port[control]:=$22;
    tick:=meml[$40:$006c];
    repeat until (not ready or ((meml[$40:$006c]-tick)>2));
    recv:=not ready;
  end else
  begin
    recv:=false;
    writeln('recv false');
  end;
  port[control]:=$20;
end;

function stringrecv: string;
var
  s: string;
  c: byte;
begin
  s:='';
  recv(c);
  while (c>=$20) do
  begin
    s:=s+chr(c);
    recv(c);
  end;
  stringrecv:=s;
end;



function sendfile(load: word; filename: string): word;
var
  f         : file;
  fheader   : array[0..15] of byte;
  buf       : array[1..2048] of byte;
  i,j,nr    : word;
  fl,bl     : word;
  tick      : longint;
begin;
   bl:=sizeof(buf);
   assign(f,filename);
   reset(f,1);
   blockread(f,fheader,16,nr);
   fl:=fheader[$9]*$100+fheader[$8];
   writeln('Load address  : ',hex(fheader[1]),hex(fheader[0]),
           '  ',hex(load div $100),hex(load and $ff));
   writeln('Exec address  : ',hex(fheader[5]),hex(fheader[4]));
   writeln('Length        : ',hex(fheader[9]),hex(fheader[8]));
   writeln;
   write(  'Position      : ',whex(0));
   if load<>0 then
   begin
     fheader[1]:=load div $100;
     fheader[0]:=load and $ff;
   end;
   i:=fheader[1]*$100+fheader[0]+
      fheader[9]*$100+fheader[8];
   send(fheader[$0]);
   send(fheader[$1]);
   send(i and $ff);
   send(i div $100);
   i:=fl;
   j:=1;
   tick:=meml[seg0040:$6c];
   blockread(f,buf,bl,nr);
   while i>0 do
   begin
     send(buf[j]);
     inc(j);
     if j>bl then
     begin
       blockread(f,buf,bl,nr);
       j:=1;
       write(#08#08#08#08,whex(fl-i+1));
     end;
     dec(i);
   end;
   writeln(#08#08#08#08,whex(fl));
   tick:=meml[seg0040:$6c]-tick;
   if tick>0 then writeln('Transfer-rate : ',
   (fl*18.2/tick):0:0,' bytes/s');
   close(f);
   sendfile:=fheader[5]*$100+fheader[4];
end;

function FileExists(FileName: String): Boolean;
var
  F: file;
begin
  {$I-}
  Assign(F, FileName);
  FileMode := 0;
  Reset(F);
  Close(F);
  {$I+}
  FileExists := (IOResult = 0) and (FileName <> '');
end;

function parsename(name: string;dir: char): string;
var
  i,j : word;
  q   : string;
  d   : char;
begin
  q:=name;
  d:=dir;
  i:=pos('"',q);
  while i>0 do
  begin
    q[i]:=' ';
    i:=pos('"',q);
  end;

  while ((q[1]=' ') and (length(q)>0)) do delete(q,1,1);

  if q[1]=':' then q:=copy(q,4,length(q)-3);

  if q[2]='.' then
  begin
    d:=q[1];
    q:=copy(q,3,length(q)-2);
  end;
  q:=d+q;

  i:=pos(' ',q);
  if i>0 then q:=copy(q,1,i-1);

  i:=pos('.',q);
  while i>0 do
  begin
    q[i]:='_';
    i:=pos('.',q);
  end;

  i:=pos('/',q);
  while i>0 do
  begin
    q[i]:='_';
    i:=pos('/',q);
  end;

  i:=pos('\',q);
  while i>0 do
  begin
    q[i]:='_';
    i:=pos('\',q);
  end;

  i:=pos('?',q);
  while i>0 do
  begin
    q[i]:='_';
    i:=pos('?',q);
  end;

  i:=pos('*',q);
  while i>0 do
  begin
    q[i]:='_';
    i:=pos('*',q);
  end;

  d:=q[1];
  delete(q,1,1);
  parsename:=q+'.'+d;
end;

function parsecommand(command: string): string;
var
  q,r : string;
  i,j : word;
begin
  i:=pos(' ',command);
  if i>0 then
  begin
    q:=copy(command,1,i-1);
    r:=copy(command,i+1,length(command)-i);
  end else
  begin
    q:=command;
    r:='';
  end;
  for i := 1 to Length(q) do
    q[i] := UpCase(q[i]);
  for i := 1 to Length(r) do
    r[i] := UpCase(r[i]);
  parsecommand:=q+' '+r;
  i:=pos(q,'DIRCD');
  case i of
    1 : if r<>'' then dirname:=r[1];
    4 : chdir(r);
    else parsecommand:='';
  end;
end;

procedure osfile;
var
  filename     : string;
  f            : file;
  buf          : array[1..2048] of byte;
  nw,nr        : word;
  fl,bl        : word;
  header       : array[0..15] of byte;
  fheader      : array[0..15] of byte;
  i,j          : word;
  k,l          : byte;
  tick         : longint;
begin
  bl:=sizeof(buf);
  recv(k);
  write('Osfile (',hex(k),')   - ');

  case k of
    $00 : begin
            send($00);
            filename:=stringrecv;
            for i:=0 to 15 do
            begin
              recv(header[i]);
            end;

            writeln('Save a block of memory');
            write('Filename      : ',filename);
            filename:=parsename(filename,dirname);
            writeln(' (',filename,')');

            assign(f,filename);
            rewrite(f,1);

            send($00);

            send(header[$8]);
            send(header[$9]);
            send(header[$c]);
            send(header[$d]);

            fl:=header[$d]*$100+header[$c]-
                header[$9]*$100+header[$8];
            header[$8]:=fl and $ff;
            header[$9]:=fl shr 8;
            for i:=10 to 15 do header[i]:=0;
            blockwrite(f,header,16,nw);

            writeln('Load address  : ',hex(header[1]),hex(header[0]));
            writeln('Exec address  : ',hex(header[5]),hex(header[4]));
            writeln('Length        : ',hex(header[9]),hex(header[8]));
            writeln;
            write(  'Position      : ',whex(0));

            i:=fl;
            j:=0;
            tick:=meml[seg0040:$006c];
            while i>0 do
            begin
              recv(k);
              inc(j);
              buf[j]:=k;
              if j=bl then
              begin
                blockwrite(f,buf,j,nw);
                j:=0;
                write(#08#08#08#08,whex(fl-i+1));
              end;
              dec(i);
            end;

            writeln(#08#08#08#08,whex(fl));

            if j>0 then blockwrite(f,buf,j,nw);

            tick:=meml[seg0040:$6c]-tick;
            if tick>0 then writeln('Transfer-rate : ',
                                   (fl*18.2/tick):0:0,' bytes/s');
            close(f);
            writeln;
          end;
    $01: begin
            send($00);
            writeln('Write catalogue information');
            writeln('Filename      : ',filename);
          end;
    $02 : begin
            send($00);
            writeln('Write load address');
            writeln('Filename      : ',filename);
          end;
    $03 : begin
            send($00);
            writeln('Write execution address');
            writeln('Filename      : ',filename);
          end;
    $04 : begin
            send($00);
            writeln('Write attributes');
            writeln('Filename      : ',filename);
          end;
    $05 : begin
            send($00);
            writeln('Read catalogue information');
            writeln('Filename      : ',filename);
          end;
    $06 : begin
            send($00);
            writeln('Delete file');
            writeln('Filename      : ',filename);
          end;
    $ff : begin
            send($00);
            filename:=stringrecv;
            for i:=0 to 15 do
            begin
              recv(header[i]);
            end;

            writeln('Load the named file');
            write('Filename      : ',filename);
            filename:=parsename(filename,dirname);
            writeln(' (',filename,')');

            if fileexists(filename) then
            begin
              send($00);
              if header[$04]=0 then
                sendfile(header[1]*$100+header[0],filename)
              else sendfile(0,filename);
            end else
            begin
              writeln('File not found');
              send($d6);
            end;
            writeln;
          end;
    else
    begin
      writeln;
      send($00);
    end;
  end;
end;

procedure osargs;
var k: byte;
begin
  recv(k);
  writeln('Osargs (',hex(k),')   - ');
  send($00);
end;

procedure osbget;
var k: byte;
begin
  recv(k);
  writeln('Osbget (',hex(k),')   - ');
  send($00);
end;

procedure osbput;
var k: byte;
begin
  recv(k);
  writeln('Osbput (',hex(k),')   - ');
  send($00);
end;

procedure osgbpb;
var k: byte;
begin
  recv(k);
  writeln('Osgbpb (',hex(k),')   - ');
  send($00);
end;

procedure osfind;
var
  k,l  : byte;
begin
  recv(k);
  writeln('Osfind (',hex(k),')   - ');
  send($00);
end;

procedure osfsc;
var
  filename     : string;
  pcom         : string;
  k,l          : byte;
  i,j          : word;
  DirInfo      : SearchRec;

begin
  recv(k);
  write('Osfsc  (',hex(k),')   - ');
  case k of
    $02 : begin
            send($00);
            writeln('*/ command');
            filename:=stringrecv;
            write('Filename      : ',filename);
            filename:=parsename(filename,dirname);
            writeln(' (',filename,')');
            if fileexists(filename) then
            begin
              send($00);
              i:=sendfile(0,filename);
              send(i and $ff);
              send(i div $100);
            end else
            begin
              writeln('File not found');
              send($d6);
            end;
            writeln;
          end;
    $03 : begin
            send($00);
            writeln('Unrecognised operating system command');
            filename:=stringrecv;
            pcom:=parsecommand(filename);
            if pcom='' then
            begin
              write('Filename      : ',filename);
              filename:=parsename(filename,dirname);
              writeln(' (',filename,')');
              if fileexists(filename) then
              begin
                send($01);
                i:=sendfile(0,filename);
                send(i and $ff);
                send(i div $100);
              end else
              begin
                writeln('Bad command');
                writeln;
                send($00);
                pcom:='Wat moet ik hier nou mee!';
                for i:=1 to length(pcom) do
                  while not send(ord(pcom[i])) do;
                while not send($0d) do;
                while not send($0a) do;
                send($00);
              end;
            end else
            begin
              writeln(pcom);
              writeln;
              send($00);
              send($00);
            end;
            writeln;
          end;
    $04 : begin
            send($00);
            writeln('*RUN command');
            filename:=stringrecv;
            write('Filename      : ',filename);
            filename:=parsename(filename,dirname);
            writeln(' (',filename,')');
            if fileexists(filename) then
            begin
              send($00);
              i:=sendfile(0,filename);
              send(i and $ff);
              send(i div $100);
            end else
            begin
              writeln('File not found');
              send($ff);
              send($b2);
            end;
            writeln;
          end;
    $05 : begin
            send($00);
            writeln('*CAT command');

            filename:=stringrecv;
            writeln('Filename      : ',filename);

            if filename='' then filename:='*.*';

            send($00);

            getdir(0,pcom);
            pcom:='Directory of '+pcom;
            for i:=1 to length(pcom) do
              while not send(ord(pcom[i])) do;

            while not send($0d) do;
            while not send($0a) do;

            pcom:='Current dir: '+dirname;
            for i:=1 to length(pcom) do
              while not send(ord(pcom[i])) do;

            FindFirst(filename, Anyfile, DirInfo);

            while not send($0d) do;
            while not send($0a) do;
            while not send($0d) do;
            while not send($0a) do;
            while DosError = 0 do
            begin
              filename:=dirinfo.name;

              if (dirinfo.attr and directory)>0 then
                filename:='['+filename+']      '
              else
              begin
                i:=pos('.',filename);
                if i>0 then
                begin
                  delete(filename,i,1);
                  while length(filename)<12 do
                    insert(' ',filename,i);
                end;
              end;
              i:=length(filename)+1;
              while length(filename)<20 do
                insert(' ',filename,i);
              Write(filename);
              for i:=1 to length(filename) do
                while not send(ord(filename[i])) do;
              FindNext(DirInfo);
            end;
            while not send($0d) do;
            while not send($0a) do;
            send($00);
            writeln;writeln;
          end;
    else
    begin
      writeln;
      send($00);
    end;
  end;
end;


BEGIN
  data:=0;

  if paramstr(1)='1' then
  begin
    data:=$378;
    status:=$379;
    control:=$37a;
  end;
  if paramstr(1)='2' then
  begin
    data:=$278;
    status:=$279;
    control:=$27a;
  end;
  if paramstr(1)='3' then
  begin
    data:=$3bc;
    status:=$3bd;
    control:=$3be;
  end;
  if data=0 then
  begin
    writeln('Usage  : USER <PARALLEL PORT X>');
    writeln('Example: USER 1');
    writeln;
    writeln('PARALLEL PORT 1: 0x378');
    writeln('              2: 0x278');
    writeln('              3: 0x3BC');
    exit;
  end;

  port[control]:=$22;
  clrscr;
  port[control]:=$20;
  dirname:='$';
  repeat
    repeat until (ready or keypressed);
    if keypressed then halt;
    recv(a);
    case a of
      0: osfile;
      1: osargs;
      2: osbget;
      3: osbput;
      4: osgbpb;
      5: osfind;
      6: osfsc;
    end;
  until keypressed;
END.