program extract_dfs;

uses dos,crt;

const
  hx         : array[0..$f] of char =
               '0123456789ABCDEF';

var
  fi         : file;
  nr, nw     : word;
  sector0    : array[0..255] of byte;
  sector1    : array[0..255] of byte;
  name       : array[0..31]  of string;
  data       : array[0..31,0..7]  of byte;
  i, j, l, p : byte;



function hex(v: byte): string;
begin
  hex:=hx[v shr 4] + hx[v and $f];
end;

function parsename(name: string): string;
var
  i,j : word;
  q   : string;
  d   : char;
begin
  d:=name[8];
  q:=copy(name,1,7);
  q:=d+q;

  i:=8;
  while q[i]=' ' do
  begin
    delete(q,i,1);
    dec(i);
  end;

  i:=pos(' ',q);
  while i>0 do
  begin
    q[i]:='_';
    i:=pos(' ',q);
  end;

  i:=pos('.',q);
  while i>0 do
  begin
    q[i]:='_';
    i:=pos('.',q);
  end;

  i:=pos('/',q);
  while i>0 do
  begin
    q[i]:='_';
    i:=pos('/',q);
  end;

  i:=pos('\',q);
  while i>0 do
  begin
    q[i]:='_';
    i:=pos('\',q);
  end;

  i:=pos('?',q);
  while i>0 do
  begin
    q[i]:='_';
    i:=pos('?',q);
  end;

  i:=pos('*',q);
  while i>0 do
  begin
    q[i]:='_';
    i:=pos('*',q);
  end;

  d:=q[1];
  delete(q,1,1);
  parsename:=q+'.'+d;
end;

procedure writebbc(filnum: byte; name: string);
var
  fo       : file;
  t        : string;
  sectorp  : array[0..3] of byte;
  b        : longint absolute sectorp;
  l, nr ,nw: word;
  i        : byte;

begin
  t:=paramstr(2)+name;
  t:=parsename(t);
  writeln(t);
  assign(fo,t);
  rewrite(fo,1);

  sector0[0]:=data[filnum,0];
  sector0[1]:=data[filnum,1];
  sector0[2]:=$ff;
  sector0[3]:=$ff;
  sector0[4]:=data[filnum,2];
  sector0[5]:=data[filnum,3];
  sector0[6]:=$ff;
  sector0[7]:=$ff;
  sector0[8]:=data[filnum,4];
  sector0[9]:=data[filnum,5];
  sector0[10]:=$00;
  sector0[11]:=$00;
  sector0[12]:=$00;
  sector0[13]:=$00;
  sector0[14]:=$00;
  sector0[15]:=$00;
  for i:=0 to 15 do write(hex(sector0[i]),' ');
  writeln;
  writeln;
  blockwrite(fo,sector0,16,nw);

  sectorp[3]:=0;
  sectorp[2]:=data[filnum,6];
  sectorp[1]:=data[filnum,7];
  sectorp[0]:=0;
  l:=16+data[filnum,5]*$100 + data[filnum,4];
{  gotoxy(1,22);
  write(hex(data[filnum,6]), hex(data[filnum, 7]), '00');
  gotoxy(1,24);
  writeln('Writing ',l,' bytes in file: ', name,'                ');}
  seek(fi, b);
  for i:=0 to data[filnum,5] do
  begin
    blockread(fi, sector0, 256, nr);
    blockwrite(fo, sector0, nr, nw);
  end;
  seek(fo,l);
  truncate(fo);
  close(fo);
end;


BEGIN
  clrscr;
  assign(fi, ParamStr(1));
  reset(fi,1);
  blockread(fi, sector0, 256, nr);
  blockread(fi, sector1, 256, nr);
  l:=sector1[5] shr 3;

  for i:=1 to l do
  begin
    for j:=0 to 7 do
    begin
      p:=i*8 + j;
      name[i]:=name[i]+chr(sector0[p] and $7f);
      data[i,j]:=sector1[p];
    end;

    data[i,6]:=data[i,6] and 3;
    data[i,7]:=sector1[i*8 + 7];
{    writeln(name[i],'  ',hex(data[i,1]),hex(data[i,0]),' ',
            hex(data[i,3]),hex(data[i,2]),' - ',
            hex(data[i,5]),hex(data[i,4]),' ',
            hex(data[i,6]),hex(data[i,7]));}
    end;

  for i:=1 to l do
  begin
    writebbc(i, name[i]);
  end;

END.